<template>
  <div class="home">
    <div class="banner">
      <img src="../assets/pilot3.svg" class="d-none d-md-block" />
      <div class="container">
        <div class="row d-none d-md-block">
          <div class="col-12">
            <div class="logo">
              <img src="../assets/logo8.svg" />
              Scepter
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-12 col-lg-6">
            <div class="login-box">
              <div class="container-fluid">
                <div class="row">
                  <div class="col-12">
                    <div
                      class="logo d-flex d-md-none"
                      style="display:flex; justify-content: center; margin-top:20px;"
                    >
                      <img src="../assets/logo8.svg" />
                      Scepter
                    </div>
                  </div>
                </div>
                <div class="row">
                  <div class="col-12 col-lg-6">
                    <div class="input">
                      <label>Email</label>
                      <div class="input-wrapper">
                        <input class="email-input"
                          type="text"
                          placeholder="Email"
                          v-model="email"
                          @keypress.enter="loginClicked"
                        />
                      </div>
                    </div>
                  </div>
                  <div class="col-12 col-lg-6">
                    <div class="input">
                      <label>Password</label>
                      <div class="input-wrapper">
                        <input class="password-input"
                          type="password"
                          placeholder="Password"
                          v-model="password"
                          @keypress.enter="loginClicked"
                        />
                      </div>
                    </div>
                  </div>
                </div>
                <div class="row">
                  <div class="col-12 col-lg-8 order-2 order-lg-1">
                    <router-link :to="{ name: 'Home' }">
                      <button class="button block button-link">
                        I want to register an account
                      </button>
                    </router-link>
                  </div>
                  <div class="col-lg-4 order-1 order-lg-2">
                    <button
                      class="button block signin"
                      @click="loginClicked"
                      :disabled="isLoading"
                    >
                      <span v-if="!isLoading"
                        ><i class="fas fa-lock"></i>Sign in</span
                      >
                      <span v-else><i class="fas fa-spinner fa-spin"></i></span>
                    </button>
                  </div>
                </div>
                <div class="social-login">
                  <div class="title">
                    <div class="text">Social Login</div>
                  </div>
                  <div class="row">
                    <div class="col-12 col-md-6">
                      <button
                        class="button block button-provider"
                        @click="loginWithGoogleClicked"
                      >
                        <img src="../assets/google.png" class="logo" alt="" />
                        Sign in with google
                      </button>
                    </div>
                    <div class="col-12 col-md-6">
                      <button
                        class="button block button-provider"
                        @click="loginWithMicrosoftClicked"
                      >
                        <img
                          src="../assets/microsoft.png"
                          class="logo"
                          alt=""
                        />
                        Sign in with Microsoft
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations, mapState, mapActions } from "vuex";

export default {
  name: "Home",
  data() {
    return {
      email: "",
      password: ""
    };
  },
  methods: {
    loginClicked() {
      this.login({ email: this.email, password: this.password })
        .then(() => {
          this.$router.push({ name: "Dashboard" });
        })
        .catch(error => {
          this.$toasters["main"].error(error.message);
        });
    },
    loginWithGoogleClicked() {
      this.loginWithGoogle()
        .then(() => {
          this.$router.push({ name: "Dashboard" });
        })
        .catch(error => {
          this.$toasters["main"].error(error.message);
        });
    },
    loginWithMicrosoftClicked() {
      this.loginWithMicrosoft()
        .then(() => {
          this.$router.push({ name: "Dashboard" });
        })
        .catch(error => {
          this.$toasters["main"].error(error.message);
        });
    },
    ...mapMutations(["toggleDarkMode"]),
    ...mapActions("userModule", [
      "login",
      "loginWithGoogle",
      "loginWithMicrosoft"
    ])
  },
  computed: {
    ...mapState(["darkMode", "isLoading"]),
    ...mapState("userModule", ["error"])
  }
};
</script>

<style lang="scss">
.home {
  position: absolute;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  background-color: #e6fff6;

  .banner {
    width: 100%;
    min-height: 600px;
    overflow: hidden;
    padding-bottom: 150px;
    position: relative;
    background-color: #e6faff;
    padding-top: 20px;
    & > img {
      position: absolute;
      bottom: 100px;
      right: -150px;
      height: calc(110%);
    }
  }
  .logo {
    img {
      margin-right: 20px;
    }
    display: flex;
    align-items: center;
    font-weight: bold;
    font-family: Raleway, "sans-serif";
    font-size: 24px;
    color: #7f00e2;
  }
  .login-box {
    padding-top: 15px;
    padding-bottom: 15px;
    margin-top: 50px;
    background-color: white;
    width: 100%;
    box-shadow: 0px 0px 40px rgba(0, 0, 0, 0.25);
    border-radius: 8px;
    overflow: hidden;
    .row {
      margin-bottom: 10px;
    }
    .error {
      width: 100%;
      background-color: #c60701;
      color: white;
      font-size: 15px;
      font-weight: 600;
      padding: 10px;
    }
    .input-wrapper {
      background-color: white !important;
      border: 1px solid #ccd8ef !important;
    }
    .signin {
      color: white !important;
      font-size: 0.9rem;
      font-family: "Open Sans", "sans-serif";
      background-color: #212730 !important;
    }
    .button-provider {
      background-color: white !important;
      box-shadow: 0px 0px 20px rgba(0, 0, 0, 0.25);
      border: none !important;
      color: #404c5f !important;
      font-family: Roboto, "sans-serif";
      display: flex;
      align-items: center;
      justify-content: center;
      .logo {
        margin-right: 10px;
        display: inline;
        height: 25px;
      }
      margin-bottom: 15px;
    }
    .social-login {
      margin-top: 40px;
      .title {
        position: relative;
        border-top: 1px solid #e4e4e4;
        margin-bottom: 30px;
        .text {
          background-color: white;
          position: Absolute;
          left: 50%;
          top: 0;
          transform: translate(-50%, -50%);
          padding-left: 25px;
          padding-right: 25px;
          font-weight: 600;
          color: #4c5a6f;
        }
      }
    }
  }
}
</style>
